import React from "react";
import style from "../index.less";
import check_circle from '../img/check-circle.png';
import check_right from '../img/check-right.png';
import {getStatusImg} from '@utils/tools';

class WrapModalTableSon extends React.Component {
  constructor(props) {
    super(props)
    this.getImgPath = this.getImgPath.bind(this)
  }
  getImgPath(name,groupName,item){
    const { checkedList,selectOneCheck } = this.props;
    let num = 0;
    for(let k = 0;k < checkedList.length;k++){
      let tmpLis = checkedList[k];
      if(tmpLis == name){
        return <img className={style.check} onClick={()=>selectOneCheck(name,groupName,item)} src={check_right} alt="" />
      }else{
        ++num
      }
    }
    if(num == checkedList.length){
      return <img className={style.check} onClick={()=>selectOneCheck(name,groupName,item)} src={check_circle} alt="" />
    }
  }
  render() {
    const { hospitalSonInspect,allCheckImport,allCheck,selectWaring } = this.props;
    return <div className={style['modalTable']}>
      <div className={style.sonTitle}>
        <span>组名称 : {hospitalSonInspect.groupName}</span><span className={style.btn} onClick={selectWaring}>选中异常值数据</span>
      </div>
      <div className={`${style.SonTable}`}>
        <table>
          <tr className={style.head}>
            <td className={`${style.fst} ellipsOver`} onClick={allCheckImport}><img className={style.check} src={allCheck?check_right:check_circle} alt="" />全选</td>
            <td className={`${style.sec} ellipsOver`}>编号</td>
            <td className={`${style.trd} ellipsOver`}>项目名称</td>
            <td className={`${style.four} ellipsOver`}>结果</td>
            <td className={`${style.fif} ellipsOver`}>单位</td>
            <td className={`${style.six} ellipsOver`}>参考值</td>
            <td className={`${style.sev} ellipsOver`} style={{display:(hospitalSonInspect && hospitalSonInspect.lisExcelWrapper && hospitalSonInspect.lisExcelWrapper.length)>5?'':'none'}}></td>
          </tr>
        </table>
      </div>
      <div className={`${style.parentTable} ${style.SonTable}`}>
        <table>
          {/* {type-0正常1异常2上升3下降} */}
          {
            hospitalSonInspect && hospitalSonInspect.lisExcelWrapper && hospitalSonInspect.lisExcelWrapper.map((item, idx) => {
              return <tr>
                <td className={`${style.fst} ellipsOver`}>
                  {
                    this.getImgPath(item.itemName,hospitalSonInspect.groupName,item)
                  }
                </td>
                <td className={`${style.sec} ellipsOver`}>{idx+1}</td>
                <td title={item.itemName} className={`${style.trd} ellipsOver`}>{item.itemName}</td>
                <td title={item.value} className={`${style.four} ellipsOver`}>
                  {
                    getStatusImg(item.type,item.value,0)
                  }
                </td>
                <td title={item.unit} className={`${style.fif} ellipsOver`}>{item.unit}</td>
                <td title={`${item.min}-${item.max}`} className={`${style.six} ellipsOver`}>{item.min}-{item.max}</td>
              </tr>
            })
          }
        </table>
      </div>
    </div>
  }
}

export default WrapModalTableSon;