import React from 'react';
import {
  connect
} from 'react-redux';
import Inspect from '@components/Inspect';
import {
  getSearchList,
  getSublableList,
  getImportList,
  getSonDetailList
} from '@store/async-actions/inspect';
import {
  setLabel,
  fillActived,
  fillActiveDetail,
  checkValueIsChange,
  delExcelLis,
  clearLabel,
  delPartItem,
  allCheckImport,
  selectOneCheck,
  selectWaring,
  showInIcss
} from '@store/actions/inspect';
import {
  billing,
  getConceptDetail
} from '@store/async-actions/pushMessage';

function mapStateToProps(state) {//console.log(state.inspect)
  return {
    list: state.inspect.list,
    labelList: state.inspect.labelList,
    fillActive: state.inspect.fillActive,
    getExcelDataList: state.inspect.getExcelDataList,
    labelListActive: state.inspect.labelListActive,
    inspectList: state.homePage.inspectList,
    windowHeight: state.homePage.windowHeight,
    inspectVal: state.inspect.inspectVal,
    message: state.patInfo.message,
    hospitalMsg: state.patInfo.hospitalMsg,
    hospitalInspect: state.inspect.hospitalInspect,
    hospitalSonInspect: state.inspect.hospitalInspectObj,
    allCheck: state.inspect.allCheck,
    selectGroupList: state.inspect.selectGroupList,
    checkedList: state.inspect.checkedList,
  }
}

function mapDispatchToProps(dispatch, store) {
  return {
    showInIcss(){
      dispatch(showInIcss())
    },
    selectWaring(){
      dispatch(selectWaring())
    },
    selectOneCheck(name,groupName,item){
      dispatch(selectOneCheck(name,groupName,item))
    },
    allCheckImport(data) {
      dispatch(allCheckImport(data))
    },
    handleSearch(data) {
      dispatch(getImportList(data))
    },
    handleGetSonList(name) {
      dispatch(getSonDetailList(name))
    },
    handleChangeValue(val) {
      dispatch(getSearchList(val))
    },
    getInfomation(item) {
      dispatch(getConceptDetail(item))
    },
    handleSign(id, idx, type) {
      dispatch(setLabel(idx, type))
      dispatch(getSublableList(id))
    },
    handleLabelSub(e, id, idx) {
      dispatch(fillActived(id, idx))
      // e.stopPropagation()
    },
    handleClear(e, idx) {
      e.stopPropagation();
      dispatch(clearLabel(idx))
    },
    handleConfirm(e, idx, time, arr) {
      e.stopPropagation();
      dispatch(checkValueIsChange(idx, time, arr))
    },
    changeActivePart(idx, value) {
      dispatch(fillActiveDetail(idx, value))
    },
    handleCloseExcel(idx) {
      dispatch(delExcelLis(idx));
    },
    delPartItem(idx) {
      dispatch(delPartItem(idx))
    },
    //右侧推送
    fetchPushInfos() {
      //调右侧推送
      dispatch(billing());
    }
  }
}

const InspectAction = connect(mapStateToProps, mapDispatchToProps)(Inspect);

export default InspectAction;